#ifndef _BGClass_H_
#define _BGClass_H_

#include <TThread.h>
#include <TObject.h>
#include <Riostream.h>

class BGClass : public TObject {
private:
    TThread fThread;

    static void Caller(void * arg) {
	TThread::SetCancelOn();
	BGClass * item = (BGClass *)arg;
	item->ThreadFunc();
	TThread::CleanUp();
    };
public:
    virtual void ThreadFunc() { };

    BGClass() : fThread(Caller, (void *)this) {
    };

    virtual ~BGClass() {
	fThread.Kill();
    };

    virtual void Start() {
	fThread.Run();
    };

    virtual void Stop(Bool_t join = kFALSE) {
	fThread.Kill();
	if (join)
	    fThread.Join();
    };

    TThread * GetThread() { 
	return &fThread;
    };

    ClassDef(BGClass, 0)
};

#endif
