#ifndef _ChGroup_h_
#define _ChGroup_h_

#include <TNamed.h>
#include "GroupInfo.h"
#include <TH1I.h>

class ChGroup : public TNamed {
private:
    GroupInfo fInfo;
    TH1I fHist;
public:
    ChGroup(const char * name, const char * title, Int_t nch) :
	TNamed(name, title),
	fInfo(fName + "_info", title, nch),
	fHist(fName + "_hist", title, 64000, 0, 64000) {
	  //	  printf("ChGroup: %s\n",name);
	  //      printf("at ChGroup: %d\n",nch);
    };
    ~ChGroup() {
    };

    Int_t Fill(Int_t ch, Double_t t) {
      //if(IsZeroGain) 
      t=(t-fInfo.GetZero(ch))*fInfo.GetGain(ch);
      if (fInfo.GetCh(ch)){
	return fHist.Fill(t);
      }
	return 0;
    };

    void Draw(Option_t * opt = "") {
	fHist.Draw(opt);
    };

    GroupInfo * GetInfo() {
	return & fInfo;
    };

    TH1I * GetHist(){
      ((TObject *)(& fHist))->Write();
      return & fHist;
    }

    void Reset() {
	fHist.Reset();
    };

    ClassDef(ChGroup, 0)
};

#endif
