#include <Riostream.h>
#include "module_numbers.h"
#include <TString.h>
#include <string.h>

ChGroup *
newgroup(const char * name, const char * title)
{
    ChGroup * g = gDirectory->FindObject(name);
    if (g == NULL) {
	g = new ChGroup(name, title, TOTAL_CHANNELS);
	gDirectory->Add(g);
    }else{
      g->SetTitle(title);
      gDirectory->Add(g);
    }
    return g;
}

void
monitorparams()
{
  printf("Entering monitorparams()\n");
    gDirectory->cd("/");
//    gDirectory->ls();
    ChGroup *FWD_single, *BCK_single;
    ChGroup *FWD_double, *BCK_double;
    ChGroup *CalHist[TOTAL_CHANNELS];
    ChGroup *CutHist[TOTAL_CHANNELS][MAX_RULES];
    GroupInfo *finfo, *binfo;

    FWD_single = newgroup("FWD_single", "forward channels");
    FWD_double = newgroup("FWD_double", "forward channels");

    for (int i=0; i<TOTAL_CHANNELS; i++) 
      if(Decoder->IsCopperLite(i)||Decoder->IsKalliope(i)){
	TString temp;
	temp=Decoder->GetCounterMap(i);
	//      printf("%d: %s\n",i,temp.Data());
	
	if(strpbrk(temp.Data(),"F")){
	  FWD_single->GetInfo()->AddCh(i);
	  FWD_single->GetInfo()->SetZeroGain(i,0,1);
	  FWD_double->GetInfo()->AddCh(i);
	  FWD_double->GetInfo()->SetZeroGain(i,0,1);
	}
      }

    BCK_single = newgroup("BCK_single", "backward channels");
    BCK_double = newgroup("BCK_double", "backward channels");
    for (int i=0; i<TOTAL_CHANNELS; i++) 
      if(Decoder->IsCopperLite(i)||Decoder->IsKalliope(i)){
	TString temp;
	temp=Decoder->GetCounterMap(i);
	if(strpbrk(temp.Data(),"B")){
	  BCK_single->GetInfo()->AddCh(i);
	  BCK_single->GetInfo()->SetZeroGain(i,0,1);
	  BCK_double->GetInfo()->AddCh(i);
	  BCK_double->GetInfo()->SetZeroGain(i,0,1);
	}
    }
    //  printf("Entering FWD_single->Print()");
    FWD_single->Print();
    FWD_double->Print();

    //  printf("Entering BWD_single->Print()");
    BCK_single->Print();
    BCK_double->Print();

	
    Asymmetry * a_single = gDirectory->FindObject("Asym_FWD_single_vs_BCK_single");
    if (a_single == NULL) {
	a_single = new Asymmetry(FWD_single, BCK_single);
	gDirectory->Add(a_single);
    }
    a_single->Print();

    Asymmetry * a_double = gDirectory->FindObject("Asym_FWD_double_vs_BCK_double");
    if (a_double == NULL) {
	a_double = new Asymmetry(FWD_double, BCK_double);
	gDirectory->Add(a_double);
    }
    a_double->Print();

cerr << 0 << endl;

    Decoder->IsA()->Print();

    //    printf("TString:%s\n",Decoder->GetCounterMap(i).Data());

cerr << 1 << endl;

    Decoder->GetSingleGroupList()->Add(FWD_single);
    Decoder->GetSingleGroupList()->Add(BCK_single);
    //    Decoder->GetSingleGroupList()->Print();
cerr << 2 << endl;

    Decoder->GetSingleAsymmetryList()->Add(a_single);
    //    Decoder->GetSingleAsymmetryList()->Print();

cerr << 3 << endl;

    Decoder->GetDoubleGroupList()->Add(FWD_double);
    Decoder->GetDoubleGroupList()->Add(BCK_double);
    //    Decoder->GetDoubleGroupList()->Print();

cerr << 4 << endl;
    Decoder->GetDoubleAsymmetryList()->Add(a_double);
    //    Decoder->GetDoubleAsymmetryList()->Print();

cerr << 5 << endl;

// Decoder->GetCalHistGroupList()->Print();


  printf("Exitting monitorparams()\n");
}
