#ifndef _CommandReceiver_h_
#define _CommandReceiver_h_
#include <TObject.h>
class CommandReceiver : public TObject {
private:
    TServerSocket m_socket;
    Worker	& m_worker;
public:
    CommandReceiver(Worker & worker, Int_t port = 2222) :
	m_socket(port, /* reuse */ kTRUE ),
	m_worker(worker) {
	assert(m_socket.IsValid());
    };

    void
    ProcessTokenList(TObjArray * words) {

	TString cmd, arg;

	if (words->At(0)) {
	    cmd = ((TObjString *)words->At(0))->GetString();
	}

	if (words->At(1)) {
	    arg = ((TObjString *)words->At(1))->GetString();
	}

	printf("cmd=%s arg=%s\n", cmd.Data(), arg.Data());

	if (cmd.CompareTo("start") == 0) {
	    int run_number = 999999;
	    if (arg.IsDigit())
		run_number = arg.Atoi();

	    printf("start %d\n", run_number);

	    m_worker.Start();
	    m_worker.NewRun(run_number);

	} else if (cmd.CompareTo("stop") == 0) {
	    printf("stop\n");

	    m_worker.EndRun();
	} else if (cmd.CompareTo("pause") == 0) {
	    printf("pause\n");
	    m_worker.Pause();
	} else if (cmd.CompareTo("resume") == 0) {
	    printf("resume\n");
	    m_worker.Resume();
	} else {
	    printf("bad_cmd\n");
	}

	cerr << "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!" << endl;
    };

    void
    ProcessSocket(TSocket * s) {
	FILE * fp = fdopen(s->GetDescriptor(), "r+");

	TString str;
	str.Gets(fp);

	TObjArray * words = str.Tokenize(" \r\n");
	words->SetOwner(kTRUE);

	ProcessTokenList(words);

	words->Delete();

	fprintf(fp, "Yes, I got '%s'\n", str.Data());

	fflush(fp);
	fclose(fp);
    };

#if 0
    virtual void ThreadFunc() {
	while (TSocket * s = m_socket.Accept()) {

	    ProcessSocket(s);

	    s->Close();
	    s->Delete();
	    cerr << '.' << endl;
	}
	cerr << "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!" << endl;
    };
#endif
};

#endif
