#include    <stdio.h>
#include    <string.h>
#include    <stdlib.h>
#include    <errno.h>
#include    <sys/time.h>
#include    <fcntl.h>
#include    <math.h>
#include <netinet/in.h>

#include    "global.h"
#include    "acs_vme.h"
#include    "set_vme_module.h"


int a3n00_start_set(int m)
{
  unsigned int n;
  /*stop a3n00*/
  start_stop_a3100(m,0);
  /*clear PHA data*/
  clear_a3100_all_pha_data(m);
  /*clear LIST data*/
  clear_a3100_list_data(m);
  /*TRIGGERDLIST + PHA off*/
  n = 0x7;
  write_amr_register(m,n);
  /*start a3n00*/
  n = 0xffff;
  start_stop_a3100(m,n);

  return 0;
}

int a3n00_stop_set(int m)
{
  unsigned int n;
  n = 0;
  start_stop_a3100(m,n);
  return 0;
}

int start_stop_a3100(int module,unsigned int data)
{
  unsigned char d[4];
  unsigned int dd;
  int rtn;

  d[0] = 8;
  d[1] = 0x13;
  d[2] = (unsigned char)module;
  d[3] = 0;

  dd = htonl(data);
  rtn = v_write_to_vme(d ,4);
  rtn = v_write_to_vme((void *)&dd ,4);
  rtn = v_read_from_vme(d,4);
  rtn = (int)d[1];
  m_reg[module].acr = data;
  return rtn;
}

int clear_a3100_all_pha_data(int module)
{
  unsigned char d[4];
  int rtn;

  d[0] = 4;
  d[1] = 0x21;
  d[2] = (unsigned char)module;
  d[3] = 0;

  rtn = v_write_to_vme(d ,4);
  rtn = v_read_from_vme(d,4);
  rtn = (int)d[1];

  return rtn;
}

int clear_a3100_list_data(int module)
{/*clear list*/
  unsigned char d[4];
  int rtn;
  //  printf("clear list buff\n");
  d[0] = 4;
  d[1] = 0x11;
  d[2] = (unsigned char)module;
  d[3] = 0;

  rtn = v_write_to_vme(d ,4);
  rtn = v_read_from_vme(d,4);
  rtn = (int)d[1];

  return rtn;

}


int set_a3n00_address(int flg)
{/*send a3100 vme address*/
  int i,num = cntl.modulenum,a3100=0,a3200=0,a3300=0,a3400=0;
  unsigned char d[256];
  unsigned int *ad,data[8],n;
  size_t size;
  struct module_register *m;
  d[0] = 4 * num + 4;
  d[1] = 1;
  d[2] = (char)num;
  d[3] = 0;
  size = 4 + 4*num;
  for(i = 0 ; i < num ; i++){
    ad = (unsigned int *)&d[4 + 4*i];
    *ad = htonl(m_reg[i].address);
  }
  v_write_to_vme(d,size);
  v_read_from_vme((void *)&data[0],4);
  n = ntohl(data[0]);
  n -= 4;
  v_read_from_vme((void *)&data[0],n);
  for(i = 0 ; i < num ; i++){
    m = &m_reg[i];
    n = ntohl(data[i]);
    n &= 0xFFFF;
    m->mir = n;
    switch(n){
    case 0x3100:
      m_kind.m1[a3100] = i;
      ++a3100;
      break;
    case 0x3200:
      m_kind.m2[a3200] = i;
      ++a3200;
      break;
    case 0x3300:
      m_kind.m3[a3300] = i;
      ++a3300;
      break;
    case 0x3400:
      m_kind.m4[a3400] = i;
      ++a3400;
      break;
    default:
      break;
    }

  }
  m_kind.num1 = a3100;
  m_kind.num2 = a3200;
  m_kind.num3 = a3300;
  m_kind.num4 = a3400;
  return EXIT_SUCCESS;
}

int module_default_setting(int flg)
{
  int i,j,res;
  unsigned int value,mir;
  int num = cntl.modulenum;
  struct module_register *m;


  for(i = 0 ; i < num ; i++){
    m = &m_reg[i];
    mir = m->mir;
    //printf("module = %d\n",i);
    for(j = 0 ; j < 16 ; j++){ /* 16 = module channels */
      value = m_reg[i].ccr[j];
      res = write_ccr_register(i,j,value);
      if(mir != 0x3300){
	value = m_reg[i].czlr[j];
	res =  write_czlr_register(i,j,value);
	
	value = m_reg[i].clldr[j];
	res =  write_clldr_register(i,j,value);
      }
      if(m_reg[i].mir == 0x3400){
	value = m_reg[i].cgpwr[j];
	res =  write_cgpwr_register(i,j,value);

      }
      if(mir == 0x3300){
	value = m_reg[i].ctfsr[j];
	res =  write_ctfsr_register(i,j,value);
      }

      value = m_reg[i].ccgr[j];
      res =  write_ccgr_register(i,j,value);

      value = m_reg[i].cpmr[j];
      res =  write_cpmr_register(i,j,value);

      value = m_reg[i].cpvr[j];
      res =  write_cpvr_register(i,j,value);

      value = m_reg[i].sproicr[j];
      res =  write_sproicr_register(i,j,value);

      value = m_reg[i].nproicr[j];
      res =  write_nproicr_register(i,j,value);

    }
    value = m_reg[i].amr;
    res = write_amr_register(i,value);

    value = m_reg[i].ecpvr;
    res = write_ecpvr_register(i,value);

    value = m_reg[i].ldspvr;
    res = write_ldspvr_register(i,value);

    if(m_reg[i].mir == 0x3400){
      value = m_reg[i].comgpwr;
      res = write_comgpwr_register(i,value);
    }

    value = m_reg[i].mcsr;
    value &= 0xfff;
    res = write_mcsr_register(i,value);

  }
  return 0;
}


int write_ccr_register(int module,int channel,unsigned int value)
{
  unsigned char d[12];
  unsigned int *data;
  int rtn;

  memset((void *)d,0,12);
  d[0] = 12;
  d[1] = 0xc0;
  d[2] = (unsigned char)module;
  d[3] = (unsigned char)channel;
  d[7] = 1;

  data = (unsigned int *)&d[8];
  *data = htonl(value);

  rtn = v_write_to_vme(d ,12);
  rtn = v_read_from_vme(d,4);
  rtn = (int)d[1];
  m_reg[module].ccr[channel] = value;
  return rtn;
}


int write_czlr_register(int module,int channel,unsigned int value)
{

  unsigned char d[12];
  unsigned int *data;
  int rtn;
  memset((void *)d,0,12);
  d[0] = 12;
  d[1] = 0xc1;
  d[2] = (unsigned char)module;
  d[3] = (unsigned char)channel;
  d[7] = 1;
  data = (unsigned int *)&d[8];
  *data = htonl(value);

  rtn = v_write_to_vme(d ,12);
  rtn = v_read_from_vme(d,4);
  rtn = (int)d[1];
  m_reg[module].czlr[channel] = value;
  return rtn;
}


int write_clldr_register(int module,int channel,unsigned int value)
{

  unsigned char d[12];
  unsigned int *data;
  int rtn;
  memset((void *)d,0,12);
  d[0] = 12;
  d[1] = 0xc2;
  d[2] = (unsigned char)module;
  d[3] = (unsigned char)channel;
  d[7] = 1;
  data = (unsigned int *)&d[8];
  *data = htonl(value);

  rtn = v_write_to_vme(d ,12);
  rtn = v_read_from_vme(d,4);
  rtn = (int)d[1];
  m_reg[module].clldr[channel] = value;
  return rtn;
}

int write_cgpwr_register(int module,int channel,unsigned int value)
{

  unsigned char d[12];
  unsigned int *data;
  int rtn;
  memset((void *)d,0,12);
  d[0] = 12;
  d[1] = 0xc3;
  d[2] = (unsigned char)module;
  d[3] = (unsigned char)channel;
  d[7] = 1;
  data = (unsigned int *)&d[8];
  *data = htonl(value);

  rtn = v_write_to_vme(d ,12);
  rtn = v_read_from_vme(d,4);
  rtn = (int)d[1];
  m_reg[module].cgpwr[channel] = value;
  return rtn;
}

int write_crtr_register(int module,int channel,unsigned int value)
{
  unsigned char d[12];
  unsigned int *data;
  int rtn;
  memset((void *)d,0,12);
  d[0] = 12;
  d[1] = 0xc4;
  d[2] = (unsigned char)module;
  d[3] = (unsigned char)channel;
  d[7] = 1;
  data = (unsigned int *)&d[8];
  *data = htonl(value);

  rtn = v_write_to_vme(d ,12);
  rtn = v_read_from_vme(d,4);
  rtn = (int)d[1];
  m_reg[module].crtr[channel] = value;
  return rtn;
}

int write_cltr_register(int module,int channel,unsigned int value)
{
  unsigned char d[12];
  unsigned int *data;
  int rtn;
memset((void *)d,0,12);
  d[0] = 12;
  d[1] = 0xc5;
  d[2] = (unsigned char)module;
  d[3] = (unsigned char)channel;
  d[7] = 1;
  data = (unsigned int *)&d[8];
  *data = htonl(value);

  rtn = v_write_to_vme(d ,12);
  rtn = v_read_from_vme(d,4);
  rtn = (int)d[1];
  m_reg[module].cltr[channel] = value;
  return rtn;
}
int write_ctfsr_register(int module,int channel,unsigned int value)
{
  unsigned char d[12];
  unsigned int *data;
  int rtn;
  memset((void *)d,0,8);
  d[0] = 12;
  d[1] = 0xc7;
  d[2] = (unsigned char)module;
  d[3] = (unsigned char)channel;
  d[7] = 1;
  data = (unsigned int *)&d[8];
  *data = htonl(value);

  rtn = v_write_to_vme(d ,12);
  rtn = v_read_from_vme(d,4);
  rtn = (int)d[1];
  m_reg[module].ctfsr[channel] = value;
  return rtn;
}
int write_ccgr_register(int module,int channel,unsigned int value)
{
  unsigned char d[12];
  unsigned int *data;
  int rtn,dd,n;
  memset((void *)d,0,12);
  d[0] = 12;
  d[1] = 0xc8;
  d[2] = (unsigned char)module;
  d[3] = (unsigned char)channel;
  d[7] = 1;
  data = (unsigned int *)&d[8];
  *data = htonl(value);

  rtn = v_write_to_vme(d ,12);
  rtn = v_read_from_vme(d,4);
  rtn = (int)d[1];
  m_reg[module].ccgr[channel] = value;
  //  dd = (int)value;
  //  n = 8192 / pow(2,(double)dd);
  //  channel_gain[module][channel]= n;
  //  printf("write gain = %d data = %d\n",n,(int)value);
  return rtn;
}

int write_cpmr_register(int module,int channel,unsigned int value)
{
  unsigned char d[12];
  unsigned int *data;
  int rtn,tmp;
  memset((void *)d,0,12);
  d[0] = 12;
  d[1] = 0xc9;
  d[2] = (unsigned char)module;
  d[3] = (unsigned char)channel;
  d[7] = 1;
  data = (unsigned int *)&d[8];
  *data = htonl(value);

  rtn = v_write_to_vme(d ,12);
  rtn = v_read_from_vme(d,4);
  rtn = (int)d[1];
  m_reg[module].cpmr[channel] = value;

  tmp = (int)value;
  tmp &= 0x7;
  //  preset_mode[module][channel] = tmp;
  return rtn;
}

int write_cpvr_register(int module,int channel,unsigned int value)
{
  unsigned char d[12];
  unsigned int *data;
  int rtn;
  memset((void *)d,0,12);
  d[0] = 12;
  d[1] = 0xca;
  d[2] = (unsigned char)module;
  d[3] = (unsigned char)channel;
  d[7] = 1;
  data = (unsigned int *)&d[8];
  *data = htonl(value);

  rtn = v_write_to_vme(d ,12);
  rtn = v_read_from_vme(d,4);
  rtn = (int)d[1];
  m_reg[module].cpvr[channel] = value;
  return rtn;
}

int write_sproicr_register(int module,int channel,unsigned int value)
{
  unsigned char d[12];
  unsigned int *data;
  int rtn;
  memset((void *)d,0,8);
  d[0] = 12;
  d[1] = 0xcb;
  d[2] = (unsigned char)module;
  d[3] = (unsigned char)channel;
  d[7] = 1;
  data = (unsigned int *)&d[8];
  *data = htonl(value);

  rtn = v_write_to_vme(d ,12);
  rtn = v_read_from_vme(d,4);
  rtn = (int)d[1];

  m_reg[module].sproicr[channel] = value;
  return rtn;
}

int write_nproicr_register(int module,int channel,unsigned int value)
{
  unsigned char d[12];
  unsigned int *data;
  int rtn;
  memset((void *)d,0,8);
  d[0] = 12;
  d[1] = 0xcc;
  d[2] = (unsigned char)module;
  d[3] = (unsigned char)channel;
  d[7] = 1;
  data = (unsigned int *)&d[8];
  *data = htonl(value);

  rtn = v_write_to_vme(d ,12);
  rtn = v_read_from_vme(d,4);
  rtn = (int)d[1];

  m_reg[module].nproicr[channel] = value;
  return rtn;
}

int write_irqvr_register(int module,unsigned int value)
{
  unsigned char d[12];
  unsigned int *data;
  int rtn;
  memset((void *)d,0,8);
  d[0] = 12;
  d[1] = 0x40;
  d[2] = (unsigned char)module;
  d[3] = 0;
  d[7] = 1;
  data = (unsigned int *)&d[8];
  *data = htonl(value);

  rtn = v_write_to_vme(d ,12);
  rtn = v_read_from_vme(d,4);
  rtn = (int)d[1];

  m_reg[module].irqvr = value;
  return rtn;
}

int write_irqcr_register(int module,unsigned int value)
{
  unsigned char d[12];
  unsigned int *data;
  int rtn;
memset((void *)d,0,8);
  d[0] = 12;
  d[1] = 0x41;
  d[2] = (unsigned char)module;
  d[3] = 0;
  d[7] = 1;
  data = (unsigned int *)&d[8];
  *data = htonl(value);

  rtn = v_write_to_vme(d ,12);
  rtn = v_read_from_vme(d,4);
  rtn = (int)d[1];

  m_reg[module].irqcr = value;
  return rtn;
}
/*
int write_mcstar_register(int module,unsigned int value)
{
  unsigned char d[12];
  unsigned int *data;
  int rtn;
memset((void *)d,0,8);
  d[0] = 12;
  d[1] = 0xa2;
  d[2] = (unsigned char)module;
  d[3] = 0;
  d[7] = 1;
  data = (unsigned int *)&d[8];
  *data = htonl(value);

  rtn = v_write_to_vme(d ,12);
  rtn = v_read_from_vme(d,4);
  rtn = (int)d[1];
  m_reg[module].mcstar = value;

  return rtn;
}
*/
 /*
int write_mcstcr_register(int module,unsigned int value)
{
  unsigned char d[12];
  unsigned int *data;
  int rtn;
memset((void *)d,0,8);
  d[0] = 12;
  d[1] = 0xa3;
  d[2] = (unsigned char)module;
  d[3] = 0;
  d[7] = 1;
  data = (unsigned int *)&d[8];
  *data = htonl(value);

  rtn = v_write_to_vme(d ,12);
  rtn = v_read_from_vme(d,4);
  rtn = (int)d[1];
  m_reg[module].mcstcr = value;

  return rtn;
}
 */
int write_lbrpr_register(int module,unsigned int value)
{
  unsigned char d[12];
  unsigned int *data;

  int rtn;
  memset((void *)d,0,8);
  d[0] = 12;
  d[1] = 0x45;
  d[2] = (unsigned char)module;
  d[3] = 0;
  d[7] = 1;
  data = (unsigned int *)&d[8];
  *data = htonl(value);

  rtn = v_write_to_vme(d ,12);
  rtn = v_read_from_vme(d,4);
  rtn = (int)d[1];
  m_reg[module].lbrpr = value;

  return rtn;
}

int write_lbefr_register(int module,unsigned int value)
{
  unsigned char d[12];
  unsigned int *data;

  int rtn;
  memset((void *)d,0,8);
  d[0] = 12;
  d[1] = 0x46;
  d[2] = (unsigned char)module;
  d[3] = 0;
  d[7] = 1;
  data = (unsigned int *)&d[8];
  *data = htonl(value);

  rtn = v_write_to_vme(d ,12);
  rtn = v_read_from_vme(d,4);
  rtn = (int)d[1];
  m_reg[module].lbefr = value;

  return rtn;
}

int write_lbffr_register(int module,unsigned int value)
{
  unsigned char d[12];
  unsigned int *data;

  int rtn;
  memset((void *)d,0,8);
  d[0] = 12;
  d[1] = 0x47;
  d[2] = (unsigned char)module;
  d[3] = 0;
  d[7] = 1;
  data = (unsigned int *)&d[8];
  *data = htonl(value);

  rtn = v_write_to_vme(d ,12);
  rtn = v_read_from_vme(d,4);
  rtn = (int)d[1];
  m_reg[module].lbffr = value;

  return rtn;
}

int write_amr_register(int module,unsigned int value)
{
  unsigned char d[12];
  unsigned int *data;

  int rtn;
  memset((void *)d,0,8);
  d[0] = 12;
  d[1] = 0x48;
  d[2] = (unsigned char)module;
  d[3] = 0;
  d[7] = 1;
  data = (unsigned int *)&d[8];
  *data = htonl(value);

  rtn = v_write_to_vme(d ,12);
  rtn = v_read_from_vme(d,4);
  rtn = (int)d[1];
  m_reg[module].amr = value;

  return rtn;
}

int write_ecpvr_register(int module,unsigned int value)
{
  unsigned char d[12];
  unsigned int *data;

  int rtn;
  memset((void *)d,0,8);
  d[0] = 12;
  d[1] = 0x49;
  d[2] = (unsigned char)module;
  d[3] = 0;
  d[7] = 1;
  data = (unsigned int *)&d[8];
  *data = htonl(value);

  rtn = v_write_to_vme(d ,12);
  rtn = v_read_from_vme(d,4);
  rtn = (int)d[1];
  m_reg[module].ecpvr = value;
  return rtn;
}

int write_ldspvr_register(int module,unsigned int value)
{
  unsigned char d[12];
  unsigned int *data;

  int rtn;
  memset((void *)d,0,8);
  d[0] = 12;
  d[1] = 0x4a;
  d[2] = (unsigned char)module;
  d[3] = 0;
  d[7] = 1;
  data = (unsigned int *)&d[8];
  *data = htonl(value);

  rtn = v_write_to_vme(d ,12);
  rtn = v_read_from_vme(d,4);
  rtn = (int)d[1];
  m_reg[module].ldspvr = value;
  return rtn;
}

int write_comgpwr_register(int module,unsigned int value)
{
  unsigned char d[12];
  unsigned int *data;

  int rtn;
  memset((void *)d,0,8);
  d[0] = 12;
  d[1] = 0x4c;
  d[2] = (unsigned char)module;
  d[3] = 0;
  d[7] = 1;
  data = (unsigned int *)&d[8];
  *data = htonl(value);

  rtn = v_write_to_vme(d ,12);
  rtn = v_read_from_vme(d,4);
  rtn = (int)d[1];
  m_reg[module].comgpwr = value;
  return rtn;

}



int write_acr_register(int module,unsigned int value)
{
  unsigned char d[12];
  unsigned int *data;

  int rtn;
  memset((void *)d,0,8);
  d[0] = 12;
  d[1] = 0x50;
  d[2] = (unsigned char)module;
  d[3] = 0;
  d[7] = 1;
  data = (unsigned int *)&d[8];
  value &= 0xffff;
  *data = htonl(value);

  rtn = v_write_to_vme(d ,12);
  rtn = v_read_from_vme(d,4);
  rtn = (int)d[1];

  m_reg[module].acr = value;
  return rtn;
}

int write_mcsr_register(int module,unsigned int value)
{
  unsigned char d[12];
  unsigned int *data;

  int rtn;
  memset((void *)d,0,8);
  d[0] = 12;
  d[1] = 0x51;
  d[2] = (unsigned char)module;
  d[3] = 0;
  d[7] = 1;
  data = (unsigned int *)&d[8];

  *data = htonl(value);

  rtn = v_write_to_vme(d ,12);
  rtn = v_read_from_vme(d,4);
  rtn = (int)d[1];
  m_reg[module].mcsr = value;

  return rtn;
}

int write_lbsemr_register(int module,unsigned int value)
{
  unsigned char d[12];
  unsigned int *data;

  int rtn;
  memset((void *)d,0,8);
  d[0] = 12;
  d[1] = 0x52;
  d[2] = (unsigned char)module;
  d[3] = 0;
  d[7] = 1;
  data = (unsigned int *)&d[8];
  value &= 0x1;
  *data = htonl(value);

  rtn = v_write_to_vme(d ,12);
  rtn = v_read_from_vme(d,4);
  rtn = (int)d[1];

  m_reg[module].lbsemr = value;

  return rtn;
}

int write_acsemr_register(int module,unsigned int value)
{
  unsigned char d[12];
  unsigned int *data;

  int rtn;
  memset((void *)d,0,8);
  d[0] = 12;
  d[1] = 0x53;
  d[2] = (unsigned char)module;
  d[3] = 0;
  d[7] = 1;
  data = (unsigned int *)&d[8];
  value &= 0x1;
  *data = htonl(value);

  rtn = v_write_to_vme(d ,12);
  rtn = v_read_from_vme(d,4);
  rtn = (int)d[1];

  m_reg[module].acsemr = value;

  return rtn;
}
/*********************************************************/

/***************************************************/
int read_module_setting(int flg)
{
  unsigned int val,mir;
  int i,j,res;
  int num = cntl.modulenum;
  struct module_register *m;

  for(i = 0 ; i < num ; i++){
    m = &m_reg[i];
    mir = m->mir;
    for(j = 0 ; j < 16 ; j++){ /* 16 = module channels */

      res = read_ccr_register(i,j,&val);

      if(mir != 0x3300){
      res =  read_czlr_register(i,j,&val);

      res =  read_clldr_register(i,j,&val);
      }
      if(mir == 0x3400){
	res =  read_cgpwr_register(i,j,&val);
      }
      if(mir == 0x3300){
	res =  read_ctfsr_register(i,j,&val);
      }

      res =  read_ccgr_register(i,j,&val);

      res =  read_cpmr_register(i,j,&val);

      res =  read_cpvr_register(i,j,&val);

      res =  read_sproicr_register(i,j,&val);

      res =  read_nproicr_register(i,j,&val);
    }
    res = read_amr_register(i,&val);

    res = read_ecpvr_register(i,&val);

    res = read_ldspvr_register(i,&val);

    if(mir == 0x3400){
      res = read_comgpwr_register(i,&val);
    }

    res = read_mcsr_register(i,&val);

    set_atic_mem(i);
  }

  return 0;
}

int read_ccr_register(int module,int channel,unsigned int *value)
{
  unsigned char d[8];
  unsigned int *data;

  int rtn;

  memset((void *)d,0,8);
  d[0] = 8;
  d[1] = 0xc0;
  d[2] = (unsigned char)module;
  d[3] = (unsigned char)channel;
  d[7] = 0;

  rtn = v_write_to_vme(d ,8);
  rtn = v_read_from_vme(d,8);

  data = (unsigned int *)&d[4];

  *value = ntohl(*data);
  m_reg[module].ccr[channel] = *value;
  return 0;
}

int read_czlr_register(int module,int channel,unsigned int *value)
{
  unsigned char d[8];
  unsigned int *data;

  int rtn;
  memset((void *)d,0,8);
  d[0] = 8;
  d[1] = 0xc1;
  d[2] = (unsigned char)module;
  d[3] = (unsigned char)channel;
  d[7] = 0;

  rtn = v_write_to_vme(d ,8);
  rtn = v_read_from_vme(d,8);

  data = (unsigned int *)&d[4];

  *value = ntohl(*data); 
  m_reg[module].czlr[channel] = *value;
  return 0;


}
int read_clldr_register(int module,int channel,unsigned int *value)
{
  unsigned char d[8];
  unsigned int *data;

  int rtn;
  memset((void *)d,0,8);
  d[0] = 8;
  d[1] = 0xc2;
  d[2] = (unsigned char)module;
  d[3] = (unsigned char)channel;
  d[7] = 0;

  rtn = v_write_to_vme(d ,8);
  rtn = v_read_from_vme(d,8);

  data = (unsigned int *)&d[4];

  *value = ntohl(*data);  
  m_reg[module].clldr[channel] = *value;
  return 0;

}
int read_cgpwr_register(int module,int channel,unsigned int *value)
{
  unsigned char d[8];
  unsigned int *data;

  int rtn;
  memset((void *)d,0,8);
  d[0] = 8;
  d[1] = 0xc3;
  d[2] = (unsigned char)module;
  d[3] = (unsigned char)channel;
  d[7] = 0;

  rtn = v_write_to_vme(d ,8);
  rtn = v_read_from_vme(d,8);

  data = (unsigned int *)&d[4];

  *value = ntohl(*data);  
  m_reg[module].cgpwr[channel] = *value;
  return 0;
}

int read_crtr_register(int module,int channel,unsigned int *value)
{
  unsigned char d[8];
  unsigned int *data;

  int rtn;
  memset((void *)d,0,8);
  d[0] = 8;
  d[1] = 0xc4;
  d[2] = (unsigned char)module;
  d[3] = (unsigned char)channel;
  d[7] = 0;

  rtn = v_write_to_vme(d ,8);
  rtn = v_read_from_vme(d,8);

  data = (unsigned int *)&d[4];

  *value = ntohl(*data);  
  m_reg[module].crtr[channel] = *value;

  return 0;


}
int read_cltr_register(int module,int channel,unsigned int *value)
{
  unsigned char d[8];
  unsigned int *data;

  int rtn;
  memset((void *)d,0,8);
  d[0] = 8;
  d[1] = 0xc5;
  d[2] = (unsigned char)module;
  d[3] = (unsigned char)channel;
  d[7] = 0;

  rtn = v_write_to_vme(d ,8);
  rtn = v_read_from_vme(d,8);

  data = (unsigned int *)&d[4];

  *value = ntohl(*data);
  m_reg[module].cltr[channel] = *value;

  return 0;

}

int read_crtr_cltr_register(int module,int channel,unsigned int *value)
{
  unsigned char d[12];
  unsigned int *data;

  int rtn;
  memset((void *)d,0,12);
  d[0] = 4;
  d[1] = 0x23;
  d[2] = (unsigned char)module;
  d[3] = (unsigned char)channel;

  rtn = v_write_to_vme(d ,4);
  rtn = v_read_from_vme(d,12);

  data = (unsigned int *)&d[4];
  value[0] = ntohl(*data);//real time
  data = (unsigned int *)&d[8];
  value[1] = ntohl(*data);//live time

  m_reg[module].crtr[channel] = value[0];
  m_reg[module].cltr[channel] = value[1];

  return 0;
}
unsigned int read_cgcr_register(int module,int channel,unsigned int *value)
{
  unsigned char d[8];
  unsigned int *data;

  int rtn;
  memset((void *)d,0,8);
  d[0] = 8;
  d[1] = 0xc6;
  d[2] = (unsigned char)module;
  d[3] = (unsigned char)channel;
  d[7] = 0;

  rtn = v_write_to_vme(d ,8);
  rtn = v_read_from_vme(d,8);

  data = (unsigned int *)&d[4];

  *value = ntohl(*data);

  return *value;
}

int read_ctfsr_register(int module,int channel,unsigned int *value)
{
  unsigned char d[8];
  unsigned int *data;

  int rtn;
  memset((void *)d,0,8);
  d[0] = 8;
  d[1] = 0xc7;
  d[2] = (unsigned char)module;
  d[3] = (unsigned char)channel;
  d[7] = 0;

  rtn = v_write_to_vme(d ,8);
  rtn = v_read_from_vme(d,8);

  data = (unsigned int *)&d[4];

  *value = ntohl(*data);
  m_reg[module].ctfsr[channel] = *value;

  return 0;

}


int read_ccgr_register(int module,int channel,unsigned int *value)
{
  unsigned char d[8];
  unsigned int *data;

  int rtn,n,ccgr;
  memset((void *)d,0,8);
  d[0] = 8;
  d[1] = 0xc8;
  d[2] = (unsigned char)module;
  d[3] = (unsigned char)channel;
  d[7] = 0;

  rtn = v_write_to_vme(d ,8);
  rtn = v_read_from_vme(d,8);

  data = (unsigned int *)&d[4];

  *value = ntohl(*data);
  m_reg[module].ccgr[channel] = *value;

  ccgr = (int)*value;
  ccgr &= 0x7;
  //  n = 8192 / pow(2,(double)ccgr);
  //  channel_gain[module][channel]= n;
  //  printf("write gain = %d data = %d",n,(int)data);
  return 0;


}
int read_cpmr_register(int module,int channel,unsigned int *value)
{
  unsigned char d[8];
  unsigned int *data;

  int rtn,tmp;
  memset((void *)d,0,8);
  d[0] = 8;
  d[1] = 0xc9;
  d[2] = (unsigned char)module;
  d[3] = (unsigned char)channel;
  d[7] = 0;

  rtn = v_write_to_vme(d ,8);
  rtn = v_read_from_vme(d,8);

  data = (unsigned int *)&d[4];

  *value = ntohl(*data); 
  m_reg[module].cpmr[channel] = *value;

  tmp = (int)*value;
  tmp &= 0x7;
  //  preset_mode[module][channel] = tmp;
  return 0;


}
int read_cpvr_register(int module,int channel,unsigned int *value)
{
  unsigned char d[8];
  unsigned int *data;

  int rtn;
  memset((void *)d,0,8);
  d[0] = 8;
  d[1] = 0xca;
  d[2] = (unsigned char)module;
  d[3] = (unsigned char)channel;
  d[7] = 0;

  rtn = v_write_to_vme(d ,8);
  rtn = v_read_from_vme(d,8);

  data = (unsigned int *)&d[4];

  *value = ntohl(*data);
  m_reg[module].cpvr[channel] = *value;
  return 0;


}
int read_sproicr_register(int module,int channel,unsigned int *value)
{
  unsigned char d[8];
  unsigned int *data;

  int rtn;
  memset((void *)d,0,8);
  d[0] = 8;
  d[1] = 0xcb;
  d[2] = (unsigned char)module;
  d[3] = (unsigned char)channel;
  d[7] = 0;

  rtn = v_write_to_vme(d ,8);
  rtn = v_read_from_vme(d,8);

  data = (unsigned int *)&d[4];

  *value = ntohl(*data);
  m_reg[module].sproicr[channel] = *value;
  return 0;

}
int read_nproicr_register(int module,int channel,unsigned int *value)
{
  unsigned char d[8];
  unsigned int *data;

  int rtn;
  memset((void *)d,0,8);
  d[0] = 8;
  d[1] = 0xcc;
  d[2] = (unsigned char)module;
  d[3] = (unsigned char)channel;
  d[7] = 0;

  rtn = v_write_to_vme(d ,8);
  rtn = v_read_from_vme(d,8);

  data = (unsigned int *)&d[4];

  *value = ntohl(*data);
  m_reg[module].nproicr[channel] = *value;
  return 0;


}
int read_irqvr_register(int module,unsigned int *value)
{
  unsigned char d[8];
  unsigned int *data;

  int rtn;
  memset((void *)d,0,8);
  d[0] = 8;
  d[1] = 0x40;
  d[2] = (unsigned char)module;
  d[3] = 0;
  d[7] = 0;

  rtn = v_write_to_vme(d ,8);
  rtn = v_read_from_vme(d,8);

  data = (unsigned int *)&d[4];
  *value = ntohl(*data);

  m_reg[module].irqvr = *value;
  return 0;


}
int read_irqcr_register(int module,unsigned int *value)
{
  unsigned char d[8];
  unsigned int *data;

  int rtn;
  memset((void *)d,0,8);
  d[0] = 8;
  d[1] = 0x41;
  d[2] = (unsigned char)module;
  d[3] = 0;
  d[7] = 0;

  rtn = v_write_to_vme(d ,8);
  rtn = v_read_from_vme(d,8);

  data = (unsigned int *)&d[4];
  *value = ntohl(*data);

  m_reg[module].irqcr = *value;
  return 0;


}

int read_lbwpr_register(int module,unsigned int *value)
{
  unsigned char d[8];
  unsigned int *data;

  int rtn;
  memset((void *)d,0,8);
  d[0] = 8;
  d[1] = 0x44;
  d[2] = (unsigned char)module;
  d[3] = 0;
  d[7] = 0;

  rtn = v_write_to_vme(d ,8);
  rtn = v_read_from_vme(d,8);

  data = (unsigned int *)&d[4];
  *value = ntohl(*data);
  m_reg[module].lbwpr = *value;
  return 0;
}
int read_lbrpr_register(int module,unsigned int *value)
{
  unsigned char d[8];
  unsigned int *data;

  int rtn;
  memset((void *)d,0,8);
  d[0] = 8;
  d[1] = 0x45;
  d[2] = (unsigned char)module;
  d[3] = 0;
  d[7] = 0;

  rtn = v_write_to_vme(d ,8);
  rtn = v_read_from_vme(d,8);

  data = (unsigned int *)&d[4];
  *value = ntohl(*data);

  m_reg[module].lbrpr = *value;
  return 0;
}
int read_lbefr_register(int module,unsigned int *value)
{
  unsigned char d[8];
  unsigned int *data;

  int rtn;
  memset((void *)d,0,8);
  d[0] = 8;
  d[1] = 0x46;
  d[2] = (unsigned char)module;
  d[3] = 0;
  d[7] = 0;

  rtn = v_write_to_vme(d ,8);
  rtn = v_read_from_vme(d,8);

  data = (unsigned int *)&d[4];
  *value = ntohl(*data);

  m_reg[module].lbefr = *value;
  return 0;
}
int read_lbffr_register(int module,unsigned int *value)
{
 unsigned char d[8];
  unsigned int *data;

  int rtn;
  memset((void *)d,0,8);
  d[0] = 8;
  d[1] = 0x47;
  d[2] = (unsigned char)module;
  d[3] = 0;
  d[7] = 0;

  rtn = v_write_to_vme(d ,8);
  rtn = v_read_from_vme(d,8);

  data = (unsigned int *)&d[4];
  *value = ntohl(*data);
  m_reg[module].lbffr = *value;
  return 0;

}
int read_amr_register(int module,unsigned int *value)
{
  unsigned char d[8];
  unsigned int *data;

  int rtn;
  memset((void *)d,0,8);
  d[0] = 8;
  d[1] = 0x48;
  d[2] = (unsigned char)module;
  d[3] = 0;
  d[7] = 0;

  rtn = v_write_to_vme(d ,8);
  rtn = v_read_from_vme(d,8);

  data = (unsigned int *)&d[4];
  *value = ntohl(*data);
  m_reg[module].amr = *value;
  return 0;

}
int read_ecpvr_register(int module,unsigned int *value)
{
  unsigned char d[8];
  unsigned int *data;

  int rtn;
  memset((void *)d,0,8);
  d[0] = 8;
  d[1] = 0x49;
  d[2] = (unsigned char)module;
  d[3] = 0;
  d[7] = 0;

  rtn = v_write_to_vme(d ,8);
  rtn = v_read_from_vme(d,8);

  data = (unsigned int *)&d[4];
  *value = ntohl(*data);
  m_reg[module].ecpvr = *value;
  return 0;


}
int read_ldspvr_register(int module,unsigned int *value)
{
  unsigned char d[8];
  unsigned int *data;

  int rtn;
  memset((void *)d,0,8);
  d[0] = 8;
  d[1] = 0x4a;
  d[2] = (unsigned char)module;
  d[3] = 0;
  d[7] = 0;

  rtn = v_write_to_vme(d ,8);
  rtn = v_read_from_vme(d,8);

  data = (unsigned int *)&d[4];
  *value = ntohl(*data);
  m_reg[module].ldspvr = *value;
  return 0;

}

unsigned int read_comgcr_register(int module,unsigned int *value)
{
  unsigned char d[8];
  unsigned int *data;

  int rtn;
  memset((void *)d,0,8);
  d[0] = 8;
  d[1] = 0x4b;
  d[2] = (unsigned char)module;
  d[3] = 0;
  d[7] = 0;

  rtn = v_write_to_vme(d ,8);
  rtn = v_read_from_vme(d,8);

  data = (unsigned int *)&d[4];
  *value = ntohl(*data);

  return *value;

}

int read_comgpwr_register(int module,unsigned int *value)
{
  unsigned char d[8];
  unsigned int *data;

  int rtn;
  memset((void *)d,0,8);
  d[0] = 8;
  d[1] = 0x4c;
  d[2] = (unsigned char)module;
  d[3] = 0;
  d[7] = 0;

  rtn = v_write_to_vme(d ,8);
  rtn = v_read_from_vme(d,8);

  data = (unsigned int *)&d[4];
  *value = ntohl(*data);
  m_reg[module].comgpwr = *value;
  return 0;

}
int read_acr_register(int module,unsigned int *value)
{
  unsigned char d[8];
  unsigned int *data;

  int rtn;
  memset((void *)d,0,8);
  d[0] = 8;
  d[1] = 0x50;
  d[2] = (unsigned char)module;
  d[3] = 0;
  d[7] = 0;

  rtn = v_write_to_vme(d ,8);
  rtn = v_read_from_vme(d,8);

  data = (unsigned int *)&d[4];
  *value = ntohl(*data);
  *value &= 0xffff;

  m_reg[module].acr = *value;


  return 0;
}

int read_mcsr_register(int module,unsigned int *value)
{
  unsigned char d[8];
  unsigned int *data;

  int rtn;
  memset((void *)d,0,8);
  d[0] = 8;
  d[1] = 0x51;
  d[2] = (unsigned char)module;
  d[3] = 0;
  d[7] = 0;

  rtn = v_write_to_vme(d ,8);
  rtn = v_read_from_vme(d,8);

  data = (unsigned int *)&d[4];
  *value = ntohl(*data);

  m_reg[module].mcsr = *value;
  return 0;


}
int read_lbsemr_register(int module,unsigned int *value)
{
  unsigned char d[8];
  unsigned int *data;

  int rtn;
  memset((void *)d,0,8);
  d[0] = 8;
  d[1] = 0x52;
  d[2] = (unsigned char)module;
  d[3] = 0;
  d[7] = 0;

  rtn = v_write_to_vme(d ,8);
  rtn = v_read_from_vme(d,8);

  data = (unsigned int *)&d[4];
  *value = ntohl(*data);
  *value &= 1; 
  m_reg[module].lbsemr = *value;
  return 0;


}
int read_acsemr_register(int module,unsigned int *value)
{
  unsigned char d[8];
  unsigned int *data;
  int rtn;
  memset((void *)d,0,8);
  d[0] = 8;
  d[1] = 0x53;
  d[2] = (unsigned char)module;
  d[3] = 0;
  d[7] = 0;

  rtn = v_write_to_vme(d ,8);
  rtn = v_read_from_vme(d,8);

  data = (unsigned int *)&d[4];
  *value = ntohl(*data);
  *value &= 1;
  m_reg[module].acsemr = *value;
  return 0;


}

int set_atic_mem(int m)
{
  unsigned int d;

  d =  m_reg[m].mcsr;
  d >>= 26;
  d &= 3;
  m_reg[m].atic = (int)d;
  return 0;
}

void
clear_list_buff(int m)
{
  int res;
  unsigned int data,d;

  data = m_reg[m].mcsr;

  d = 3;
  d <<= 13;
 
  data |= d;

  write_mcsr_register(m,data);
  res = 1;
  while(res){  /* waite for data = 0 */
    read_mcsr_register(m,&data);
    data &= d;
    res = data;
#ifdef KDEBUG
    res = 0;
#endif

  }
}

void
clear_event_count(int m)
{
  int res;
  unsigned int data,d;

  data = m_reg[m].mcsr;

  d = 1;
  d <<= 14;
  data |= d;
  write_mcsr_register(m,data);
  /* waite for data = 0 */
  res = 1;
  while(res){
    read_mcsr_register(m,&data);
    data &= d;
    res = data;
#ifdef KDEBUG
    res = 0;
#endif
  }
}

int read_module_state()
{
  unsigned int val;
/* 2 = masta/slave 3 = stand alone*/

  val = m_reg[0].mcsr;
  val &= 0x0cffffff;
  val >>= 26;

  return (int)val;
}

int read_sitcp(int module)
{
  int rtn = 0;
  int m;
  unsigned char d[4];

  m = module;

  d[0] = 4;
  d[1] = 0x26;
  d[2] = (unsigned char)m;
  d[3] = 0;

  rtn = v_write_to_vme(d ,4);

  return 0;
}

